import hypermedia.video.*;
import java.awt.*;


// Klassen Definition für Blob Tracking -------------------------------------------------
class BlobGraph {
  // Variablen
  int w, h;
  PImage input;
  PGraphics gfx;
  Boolean rec, are, cir, cen, num;
 
  
  // Konstruktor --------------------------------------------
  BlobGraph(int x, int y ){
    w = x;
    h = y;
    gfx = createGraphics(w, h, P2D);
  }
  

  // Graph Funktion -----------------------------------------  
  PGraphics track(Blob[] blobs, Boolean rec, Boolean are, Boolean cir, Boolean cen, Boolean num ){
  // blob array, rectangle, area, circumference, centroid, number  
    
    // start off screen buffer ---------
    gfx.beginDraw();
    gfx.background(200);


    // draw blob results -------------------------------------
    
    for( int i=0; i<blobs.length; i++ ) {
        
        // contours of the blob ------------------   
        gfx.stroke(255,0,0);
        gfx.fill(255);    
        gfx.beginShape();
        for( int j=0; j<blobs[i].points.length; j++ ) {
            gfx.vertex( blobs[i].points[j].x, blobs[i].points[j].y );
        }
        gfx.endShape(CLOSE);
        
        // calculate rect, area, circumference, centroid  -----------------
        Rectangle bounding_rect	= blobs[i].rectangle;
        float area = blobs[i].area;
        float circumference = blobs[i].length;

        Point centroid = blobs[i].centroid;
        Point[] points = blobs[i].points;

        // draw -----------------------------------------------------------
        // rectangle
        if (rec == true){
          gfx.noFill();
          gfx.stroke( blobs[i].isHole ? 128 : 64 );
          gfx.rect( bounding_rect.x, bounding_rect.y, bounding_rect.width, bounding_rect.height );  
          gfx.noStroke();
        }

        // Number
        if (num == true){
          gfx.fill( 255, 0, 0 );        
          gfx.text( "# " + i, centroid.x+5, centroid.y-15 );
          gfx.noStroke();          
          gfx.noFill();
        }

        // centroid
        if (cen == true){
          gfx.stroke(0,0,255);
          gfx.line( centroid.x-5, centroid.y, centroid.x+5, centroid.y );
          gfx.line( centroid.x, centroid.y-5, centroid.x, centroid.y+5 );
          gfx.noStroke();
        }
        
        // area
        if (are == true){
          gfx.fill(0,0,255);
          gfx.text( "fläche " + area,centroid.x+5, centroid.y+5 );
          gfx.noFill();    
        }
        
        // circumference
        if (cir == true){
          gfx.noStroke();
          gfx.fill(0,0,255);
          gfx.text( "umfang " + circumference, centroid.x+5, centroid.y+15 );
          gfx.noFill();
        }
    }
    
    // end off screen buffer ---------    
    gfx.endDraw();
    // return off screen bufffer to draw in window
    return gfx;
  }
  
}

  
