import hypermedia.video.*;
import java.awt.*;

OpenCV opencv;
BlobGraph graph;
int vw = 320, vh = 240;

void setup() {

    size( 960, 240 );

    // open video stream
    opencv = new OpenCV( this );
    opencv.capture(vw, vh);
    graph = new BlobGraph(vw, vh);
}

void draw() {
    // grab frame from camera --------------------------------
    opencv.read();    
    
    // draw camera image on the left -------------------------
    image(opencv.image(), 0, 0);
    
    // make a duotone image -> several threshold calcualtions available
    // move mouse on x axis to adjust threshold
    float thresh = map(mouseX, 0, 255, 0, width);
    opencv.threshold(thresh); 
    
    // draw duotone image in the middle ----------------------
    image(opencv.image(), 320, 0);

   
    // draw blobs on the right -------------------------------  
    // first track blobs, then hand them over to BlobTrack Class
    Blob[] blobs = opencv.blobs( 100, width*height/2, 100, true, OpenCV.MAX_VERTICES*4 ); 
     // blob array, rectangle, area, circumference, centroid, number  
    image(graph.track(blobs, true, false, false, true, true), 640, 0);

}


public void stop() {
    opencv.stop();
    super.stop();
}
